/**
 * Copyright (C) 2008 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LTOP_IMAGE_H__
#define __LTOP_IMAGE_H__

G_BEGIN_DECLS

#include "ltop-media.h"

enum {
    LTOP_IMAGE_STYLE_CENTERED = 0,
    LTOP_IMAGE_STYLE_TILED,
    LTOP_IMAGE_STYLE_STRETCHED,
    LTOP_IMAGE_STYLE_SCALED,
};

typedef struct _LtopImagePrivate LtopImagePrivate;
typedef struct _LtopImageClass   LtopImageClass;
typedef struct _LtopImage        LtopImage;

#define LTOP_TYPE_IMAGE            (ltop_image_get_type ())
#define LTOP_IMAGE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), LTOP_TYPE_IMAGE, LtopImage))
#define LTOP_IMAGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), LTOP_TYPE_IMAGE, LtopImageClass))
#define LTOP_IS_IMAGE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LTOP_TYPE_IMAGE))
#define LTOP_IS_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LTOP_TYPE_IMAGE))
#define LTOP_IMAGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), LTOP_TYPE_IMAGE, LtopImageClass))

struct _LtopImageClass
{
  GObjectClass __parent__;
};

struct _LtopImage
{
  GObject __parent__;

  /*< priv >*/
  LtopImagePrivate *priv;
};

GType    ltop_image_get_type  (void) G_GNUC_CONST G_GNUC_INTERNAL;

GObject *ltop_image_new       (const gchar *filename,
                               gfloat       timeout,
                               gint         style) G_GNUC_MALLOC G_GNUC_INTERNAL;
GObject *ltop_image_new_black (gfloat timeout);

G_END_DECLS

#endif /* __LTOP_IMAGE_H__ */
